<template>
  <div class="app-container">
    <el-card>
      <el-row>
        <span>合同号:</span>
        <el-select v-model="contractNumValue" placeholder="合同号" size="small" filterable clearable>
          <el-option
            v-for="item in contractNum"
            :key="item.value"
            :label="item.label"
            :value="item.value">
            <div style="float: left">{{ item.label }}</div>
            <div style="float: right; color: #8492a6; font-size: 13px">{{ item.name }}</div>
          </el-option>
        </el-select>
        <el-button type="success" size="small" icon="el-icon-search" style="margin-left:10px" @click="total=0;pageCurrent=1;pageSize=10;searchTable()">查询</el-button>
        <el-button type="primary" size="small" icon="el-icon-cjn-09" style="margin-left:10px" @click="Preservation">保存</el-button>
      </el-row>
    </el-card>
    <el-card>
      <el-table
        v-loading="loading"
        :data="tableData"
        style="width: 100%"
        size="small"
        highlight-current-row
        min-height="540px"
        height="540px"
        border>
        <el-table-column align="center" label="采购合同编号">
          <template slot-scope="scope">
            {{ scope.row.采购合同编号 }}
          </template>
        </el-table-column>
        <el-table-column align="center" label="供应商">
          <template slot-scope="scope">
            {{ scope.row.供应商名称 }}
          </template>
        </el-table-column>
        <el-table-column align="center" label="零件号" width="170px">
          <template slot-scope="scope">
            {{ scope.row.物料型号 }}
          </template>
        </el-table-column>
        <el-table-column align="center" label="零件名称" width="170px">
          <template slot-scope="scope">
            {{ scope.row.物料名称 }}
          </template>
        </el-table-column>
        <el-table-column align="center" label="数量" width="70px">
          <template slot-scope="scope">
            {{ scope.row.数量 }}
          </template>
        </el-table-column>
        <el-table-column align="center" label="重量或面积" width="150px">
          <template slot-scope="scope">
            {{ scope.row.重量或面积 }}
          </template>
        </el-table-column>
        <el-table-column align="center" label="单位" width="80px">
          <template slot-scope="scope">
            {{ scope.row.单位 }}
          </template>
        </el-table-column>
        <el-table-column align="center" label="单价" width="100px">
          <template slot-scope="scope">
            <el-input v-model="scope.row.核算单价" size="mini" width="80px" align="center" @change="update(scope.row)"/>
          </template>
        </el-table-column>
        <el-table-column align="center" label="总额" width="100px">
          <template slot-scope="scope">
            <el-input v-model="scope.row.核算总额" size="mini" width="80px" align="center" readonly/>
          </template>
        </el-table-column>
      </el-table>
      <div class="block" style="margin-top: 10px;">
        <el-pagination
          :current-page="pageCurrent"
          :page-sizes="[10, 20, 30, 40, 50]"
          :page-size="pageSize"
          :total="total"
          layout="total, sizes, prev, pager, next, jumper"
          @size-change="handleSizeChange"
          @current-change="handleCurrentChange"/>
      </div>
    </el-card>
  </div>
</template>

<script>import { initPayState, searchParts, Preservation } from '@/api/WorkshopProcurement/AccountingPrice'
import { mapGetters } from 'vuex'
export default {
  data() {
    return {
      check1: 0,
      loading: false,
      contractNumValue: '',
      contractNum: [],
      tableData: [],
      Requisition: [],
      Total: [],
      UnitPrice: [],
      pageSize: 10,
      pageCurrent: 1,
      total: 0
    }
  },
  computed: {
    ...mapGetters([
      'sidebar',
      'avatar',
      'name',
      'id' // 人员编号
    ])
  },
  created() {
    this.fetchData()
  },
  methods: {
    fetchData() {
      initPayState().then(response => {
        for (let i = 0; i < response.data.length; i++) {
          this.contractNum.push({
            label: response.data[i].采购合同编号,
            name: response.data[i].采购合同名称,
            value: response.data[i].采购合同流水号
          })
        }
      })
    },
    searchTable() {
      this.loading = true
      this.contractNumValue ? this.check1 = 1 : this.check1 = 0
      searchParts(this.pageCurrent, this.pageSize, this.check1, this.contractNumValue).then(response => {
        this.loading = false
        console.log(response.data.rows)
        for (let i = 0; i < response.data.rows.length; i++) {
          if (response.data.rows[i].物料型号 === null || response.data.rows[i].物料型号 === '') {
            response.data.rows[i].物料型号 = response.data.rows[i].零件图号
          }
        }
        this.tableData = response.data.rows
        console.log(this.tableData)
        this.total = response.data.total
      })
    },
    update(row) {
      row.核算总额 = row.核算单价 * parseFloat(row.重量或面积)
    },
    Preservation() {
      for (let i = 0; i < this.tableData.length; i++) {
        console.log(this.tableData[i].请购单明细流水号, this.tableData[i].核算总额)
        this.Requisition.push(this.tableData[i].请购单明细流水号)
        this.UnitPrice.push(this.tableData[i].核算单价)
        this.Total.push(this.tableData[i].核算总额)
      }
      Preservation(this.Requisition, this.Total, this.UnitPrice).then(response => {
        if (response.data[0].result === '1') {
          this.$message.success('保存成功')
        } else {
          this.$message.error('保存失败')
        }
      })
    },
    handleSizeChange(val) {
      this.pageSize = val
      this.pageCurrent = 1
      this.searchTable()
    },
    handleCurrentChange(val) {
      this.pageCurrent = val
      this.searchTable()
    }
  }
}
</script>

<style scoped>

</style>
